<script lang="ts">
  import type { Side } from '@svelte-common/menu/hamburger-menu/hamburger-menu.js';
  import { onMount } from 'svelte';
  import CloseMenu from '../menu/hamburger-menu/CloseMenu.svelte';
  import { drawerMenuStore, isOpened } from './stores/drawer-menu-store.js';

  export let side: Side;
  export let drawerClass: string;

  let drawer: HTMLElement;

  $: {
    if ($isOpened) {
      drawer.classList.remove('hide');
    }
  }

  const onTransitionEnd = () => {
    if (!$isOpened) {
      drawer.classList.add('hide');
    }
  };

  onMount(() => {
    // Access the .hamburger-menu element after the component is mounted
    const hamburger = document.querySelector('.hamburger-menu input[type="checkbox"]');

    const onChange = (e: Event) => {
      const target = e.target as HTMLInputElement;

      // Update the "open" variable based on the checked status
      drawerMenuStore.toggle(target.checked);
    };

    /// Listen for the "change" event on the hamburger menu input
    hamburger?.addEventListener('change', onChange);

    return () => {
      hamburger?.removeEventListener('change', onChange);
    };
  });
</script>

<div class="drawer-container {side}">
  <CloseMenu {side} />
  <aside
    bind:this={drawer}
    class="drawer {side} {$$props.drawerClass}"
    class:open={$isOpened}
    class:close={!$isOpened}
    on:transitionend={onTransitionEnd}
  >
    <slot />
  </aside>
</div>

<style>
  .drawer-container {
    --drawer-width: calc(var(--hamburger-menu-bar-width) + var(--hamburger-menu-margin) * 2);
    --drawer-animation-in: 0.25s ease-in-out;
    --drawer-animation-out: 0.2s ease-in-out;

    position: fixed;
    min-height: 100vh;
  }

  .drawer-container.right {
    right: var(--drawer-width);
  }

  .drawer {
    position: inherit;
    min-height: 100%;
    padding-top: calc(var(--hamburger-menu-bar-height) + var(--hamburger-menu-margin) + 3rem);
  }

  .drawer.left {
    translate: -100%;
  }

  .drawer.right {
    right: 0;
    translate: 100%;
  }

  /* When .open class is applied to .drawer, slide it in */
  .drawer.open {
    opacity: 1;
    transition: translate var(--drawer-animation-in), opacity var(--drawer-animation-out);
    translate: 0%;
    visibility: visible;
  }

  .drawer.close {
    opacity: 0;
    transition: translate var(--drawer-animation-out), opacity var(--drawer-animation-out) 0.1s;
    translate: 100%;
  }

  .drawer.hide {
    visibility: hidden;
  }
</style>
